artdaq - Bug #21077

SharedMemoryFragmentManager issues with multiple readers
10/09/2018 12:21 PM - Eric Flumerfelt

Status: Closed Start date: 10/09/2018
Priority: Normal Due date:

Assignee: Eric Flumerfelt % Done: 0%
Category: Needed Enhancements Estimated time: 0.00 hour
Target version: artdaq_core v3_04_03

Experiment: - Co-Assignees:

Description

When multiple processes are connected to the shared memory as readers, it is possible for ReadyForRead to return true, and then
control would enter GetBufferForReading. GetBufferForReading, however, could loop infinitely if it cannot actually reserve a buffer
because it was taken by another reader.

The fix on artdag-core/feature/SharedMemoryReader_GetBufferForReading_LimitedRetries (should be
SharedMemoryManager_GetBufferForReading_LimitedRetries) removes the infinite loop, replacing it with a more modest 5 retries.
When the function fails, SharedMemoryFragmentManager will call ReadyForRead again.

Without this change, readers in transfer_driver shmem nonblocking mode tests can hang forever near the end of data.

Related issues:
Related to artdaq - Bug #20976: multiple_art_processes_example broken Closed 09/28/2018

History

#1 - 10/09/2018 12:22 PM - Eric Flumerfelt

- Status changed from New to Resolved

[eflumerf@ironwork artdag _corel$ git checkout feature/SharedMemoryReader_GetBufferForReading_LimitedRetries
Switched to branch 'feature/SharedMemoryReader_GetBufferForReading_LimitedRetries'

[eflumerf@ironwork artdaq_corel$ git diff feature/SeplO_pdune_candidate

diff --git a/artdag-core/Core/SharedMemoryManager.cc b/artdag-core/Core/SharedMemoryManager.cc

index d0£fc529..00666£3 100644

--— a/artdag-core/Core/SharedMemoryManager.cc

+++ b/artdag-core/Core/SharedMemoryManager.cc

@@ -213,7 +213,7 Q@ void artdaqg::SharedMemoryManager: :Attach ()

else
{
TLOG (TLVL_ERROR) << "Failed to connect to shared memory segment with key 0x" << std::hex << sh
m_key_
= << ", errno = " << strerror(errno) << ". Please check "
+ << ", errno=" << errno << " (" << strerror(errno) << ")" << ". Please check "
<< "if a stale shared memory segment needs to "
<< "be cleaned up. (ipcs, ipcrm -m <segId>)";

}
@@ -229,9 +229,8 @@ int artdaqg::SharedMemoryManager: :GetBufferForReading/()
auto rp = shm_ptr_->reader_pos.load();

TLOG (13) << "GetBufferForReading lock acquired, scanning " << shm_ptr_->buffer_count << " buffers";
= bool retry = true;
int buffer_num = -1;
= while (retry)
+ for(int retry = 0; retry < 5; retry++)
{
ShmBuffer* buffer_ptr = nullptr;
uint64_t seqID = -1;
@@ -291,7 +290,7 Q@ int artdaqg::SharedMemoryManager: :GetBufferForReading/()
TLOG (13) << "GetBufferForReading returning " << buffer_num;
return buffer_num;
}
= retry = false;
+ retry = 5;

if (buffer_num==-1) TLOG(13) << "GetBufferForReading returning -1 because no buffers are ready";
#2 - 10/10/2018 02:49 PM - Eric Flumerfelt
- Related to Bug #20976: multiple_art_processes_example broken added

#3 - 10/12/2018 12:46 PM - Eric Flumerfelt

- Target version set to artdaq_core v3_04_03

#4 - 10/25/2018 01:41 PM - Eric Flumerfelt

- Status changed from Resolved to Closed
